Skip to main content

Find Increasing Triplet Subsequence - Medium


Problem - Given an integer array A[1..n], find an instance of i,j,k where 0 < i < j < k <= n and A[i] < A[j] < A[k].

Let's start with the obvious solution, bruteforce every three element combination until we find a solution.

def find_triple(arr): #O(n^3)/O(1)
N = len(arr)
for i in xrange(N):
for j in xrange(i+1,N):
for k in xrange(j+1,N):
if arr[i] < arr[j] < arr[k]:
return arr[i],arr[j],arr[k]
return None
view raw gistfile1.txt hosted with ❤ by GitHub
Let's try to reduce this by searching left and right for each element, we search left for an element smaller than the current one, towards the right an element greater than the current one. When we find an element that has both such elements, we found the solution. The complexity of this solution is O(n^2).
def find_triple(arr): #O(n^2)/O(1)
N = len(arr)
for i in xrange(N):
left = None
for j in xrange(i - 1, -1, -1):
if arr[i] > arr[j]:
left = j
break
right = None
for j in xrange(i + 1, N):
if arr[i] < arr[j]:
right = j
break
if left and right:
return arr[left],arr[i],arr[right]
return None
view raw gistfile1.txt hosted with ❤ by GitHub
To reduce this even further, One can simply apply the longest increasing subsequence algorithm and break when we get an LIS of length 3. But the best algorithm that can find an LIS is O(nlogn) with O( n ) space.

An O(nlogn) algorithm seems like an overkill! Can this be done in linear time?

The Algorithm:
We iterate over the array and keep track of two things.
  • The minimum value iterated over (min)
  • The minimum increasing pair (a,b) where min <= a < b
When we encounter an element, say v,  that is greater than the increasing pair we return (a,b,v).

Here's my Python implementation to make my point.

def find_triple(arr): #O(n)/O(1)
mn = a = arr[0]
b = None
for v in arr[1:]:
if mn >= v: # v is the new minimum
mn = v
elif b == None or b > v: # v > min but less than earlier 'b'
a,b = mn,v
else: # v > b > a
return a,b,v
return None
view raw gistfile1.txt hosted with ❤ by GitHub
Until next time, Cheers!

Comments

  1. Good job, I really like the way you explained. For the last implementation, I think you should change to "elif b == None or b >= v" otherwise it will fail on [3,2,4,4]

    ReplyDelete
  2. It has to fail for [3,2,4,4]...The question clearly states the triple should be strictly increasing.

    ReplyDelete

Post a Comment

Popular posts from this blog

Dijkstra's algorithm - Part 1 - Tutorial

This will be a 3 Part series of posts where I will be implementing the Dijkstra's Shortest Path algorithm in Python. The three parts will be 1) Representing the Graph 2) Priority Queue 3) The Algorithm To represent a graph we'll be using an  Adjacency List . Another alternative is using an Adjacency Matrix, but for a sparse graph an Adjacency List is more efficient. Adjacency List An Adjacency List is usually represented as a HashTable (or an Array) where an entry at `u` contains a Linked List. The Linked List contains `v` and optionally another parameter `w`. Here `u` and `v` are node(or vertex) labels and `w` is the weight of the edge. By Traversing the linked list we obtain the immediate neighbours of `u`. Visually, it looks like this. For implementing this in Python, we'll be using the dict()  for the main HashTable. For the Linked List we can use a list of 2 sized tuples (v,w).  Sidenote: Instead of a list of tuples, you can use a dict(), ...

Find the Quadruplets - Hard

Problem - Given 4 arrays A,B,C,D. Find out if there exists an instance where A[i] + B[j] + C[k] + D[l] = 0 Like the Find the Triple problem, we're going to develop 4 algorithms to solve this. Starting with the naive O(n^4) solution. Then we proceed to eliminate the inner-most loop with a Binary Search, reducing the complexity to O(n^3 logn) Now, we replace the last 2 loops with the left-right traversal we did in the previous 3 posts. Now the complexity is O(n^3). Finally, we reduce the complexity to O(n^2 logn) at the cost of O(n^2) Space Complexity. We store every combination of A[i] + B[j] and store it in AB[]. Similarly we make CD[] out of C[i] + D[j]. So, AB = A x B CD = C x D We then sort AB and CD (which costs O(n^2 log(n^2)) ~ O(n^2 logn) ) and then run a left-right linear Algorithm on AB and CD. (Note : Their size is of the order O(n^2)) So the overall complexity is due to sorting the large array of size n^2. which is O(n^2 logn).